(function() {
    AJS.toInit(function initHorizontalNavs($) {
        var HNavTemplates = Adaptavist.Templates.ContentFormatting.AuiHorizontalNav,
            navContainers = $('.contentf-horizontalnav');

        navContainers.each(function(index, value){
            var currentNavContainer = $(value),
                contentPanels = currentNavContainer.find('.nav-content'),
                navHeader = currentNavContainer.find('.aui-nav');

            contentPanels.each(function(index,value) {
                var currentContentPanel = $(value),
                    contentTitle = currentContentPanel.data('nav-item-title'),
                    contentId = currentContentPanel.attr('id'),
                    isInitialContentPanel = index === 0,
                    navItem = $(HNavTemplates.horizontalNavHeader({
                        title: contentTitle,
                        refId: contentId,
                        active: isInitialContentPanel
                    }));

                navItem.click(function(e) {
                    e.preventDefault();
                    switchActivePanel(index, contentPanels);
                    switchActiveNav(index, navHeader);
                });

                navHeader.append(navItem);
            });


            switchActivePanel(
                getActivePanelIndex(contentPanels),
                contentPanels);
            switchActiveNav(
                getActivePanelIndex(contentPanels),
                navHeader);
        });
    });

    function getActivePanelIndex(contentPanels) {
        var selectedId = window.location.hash,
            idIndex = contentPanels.index($(selectedId));
        return idIndex < 0 ? 0 : idIndex;
    }

    function switchActiveNav(currentIndex, navBar) {
        var navs = navBar.children('li.menu-item'),
            currentNav = navs.eq(currentIndex),
            inactiveNavs = navs.not(currentNav);
        inactiveNavs.removeClass('aui-nav-selected');
        currentNav.addClass('aui-nav-selected');
    }

    function switchActivePanel(currentIndex, contentPanels) {
        var currentPanel = contentPanels.eq(currentIndex),
            inactivePanels = contentPanels.not(currentPanel);
        inactivePanels.hide();
        currentPanel.show();
    }

})();