(function() {

    AJS.toInit(function initProgressTracker($) {
		
        var trackers = $('.contentf.aui-progress-tracker');
		// count the number of tracker steps
		var numTrackers = ($('.aui-progress-tracker-step').length);
		// get the number set in the container
		var numDataProgress = $('.contentf.aui-progress-tracker').attr('data-progress-item');

		var defaultCurrentStep = 1;
		
		// if current step is greater than the number of steps
		// warn the user 
		if (numDataProgress > numTrackers) {
			$('.aui-progress-error').addClass('aui-message warning shadowed');
			$('.aui-progress-error span').addClass('aui-icon icon-warning');			
			$('.aui-progress-error p.title').empty().text('Warning!');				
			$('.aui-progress-error p.p-bar-message').empty().text('You have set this as step number ' + numDataProgress + ' in the Progress Bar Container but there are only ' + numTrackers + ' steps in this Progress Bar.');
		} else if(numDataProgress <= 0) {
			$('.aui-progress-error').addClass('aui-message warning shadowed');
            $('.aui-progress-error span').addClass('aui-icon icon-warning');
            $('.aui-progress-error p.title').empty().text('Warning!');
            $('.aui-progress-error p.p-bar-message').empty().text('You have set this as step number ' + numDataProgress + ' in the Progress Bar Container but it should be between 1 and ' + numTrackers + ' .');
            defaultCurrentStep = 0;
		}

        trackers.each(function(index,value){
            var currentTracker = $(value),
                currentStep = parseInt(currentTracker.data('progress-item'),10)-1,

                // Current item is embedded in an attribute of the container element
                // this prevents the current item being defined multiple times, which
                // might happen if we made this an attribute of the items themselves
                steps = currentTracker.children('.aui-progress-tracker-step');
                if(defaultCurrentStep == 0){
                    currentStep = defaultCurrentStep;
                }

            // Remove non list items, because editor will not prevent this
            currentTracker.children('*:not(li)').remove();

            $.each(steps, function(index, value) {

                // Set width because this is what the example in the AUI sandbox does
                $(value).css("width",Math.floor(100/steps.length)+'%');
                if (index === currentStep) {
                    $(value).addClass('aui-progress-tracker-step-current');
                }
            });
        });

    });

})();