(function() {

    AJS.toInit(function initTabs($) {
        var AuiTabsTemplates = Adaptavist.Templates.ContentFormatting.AuiTabs,
            tabContainers = $('.contentf.aui-tabs');

        tabContainers.each(function(index, value) {
            var currentTabContainer = $(value),
                panes = currentTabContainer.children('.tabs-pane'),
                tabsMenu = currentTabContainer.children('.tabs-menu'),
                activePane = panes.eq(0);

            activePane.addClass('active-pane');

            // The tab headings are synthesised from the
            // 'pane-title' attribute of individual 'panes'.
            // This is done avoid coupling between the velocity
            // templates and the JS and to avoid inline JS.
            $.each(panes, function(index, value) {
                var currentPane = $(value),
                    currentPaneTitle = currentPane.data('pane-title'),
                    currentPaneId = currentPane.attr('id'),
                    tabsMenuItem = $(AuiTabsTemplates.tabHeader({
                        title: currentPaneTitle,
                        refId: currentPaneId,
                        active: index === 0
                    }));

                tabsMenuItem.click(function(e) {
                    switchActivePane(index, panes);
                });

                tabsMenu.append(tabsMenuItem);

            });
        });



        AJS.tabs.setup();
        setupActiveTab(tabContainers);
    });

    function getSelectedTab(tabContainers) {
        var selectedPanelId = window.location.hash,
            selectedTab = tabContainers.find("a[href='"+selectedPanelId+"']");
        return selectedTab;
    }

    function setupActiveTab(tabContainers) {
        var selectedTab = getSelectedTab(tabContainers);
        if (selectedTab.length > 0) {
            AJS.tabs.change(selectedTab);
        }
    }

    function switchActivePane(currentIndex, contentPanes) {
        var currentPanel = contentPanes.eq(currentIndex),
            inactivePanels = contentPanes.not(currentPanel);
        inactivePanels.hide();
		inactivePanels.removeClass('active-pane');
        currentPanel.show();
		currentPanel.addClass('active-pane');
    }

})();